<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLaneAccessorialRates ArrayType
 * @subpackage Arrays
 */
class ArrayOfLaneAccessorialRates extends AbstractStructArrayBase
{
    /**
     * The LaneAccessorialRates
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LaneAccessorialRates[]
     */
    public $LaneAccessorialRates;
    /**
     * Constructor method for ArrayOfLaneAccessorialRates
     * @uses ArrayOfLaneAccessorialRates::setLaneAccessorialRates()
     * @param \StructType\LaneAccessorialRates[] $laneAccessorialRates
     */
    public function __construct(array $laneAccessorialRates = array())
    {
        $this
            ->setLaneAccessorialRates($laneAccessorialRates);
    }
    /**
     * Get LaneAccessorialRates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LaneAccessorialRates[]|null
     */
    public function getLaneAccessorialRates()
    {
        return isset($this->LaneAccessorialRates) ? $this->LaneAccessorialRates : null;
    }
    /**
     * Set LaneAccessorialRates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LaneAccessorialRates[] $laneAccessorialRates
     * @return \ArrayType\ArrayOfLaneAccessorialRates
     */
    public function setLaneAccessorialRates(array $laneAccessorialRates = array())
    {
        foreach ($laneAccessorialRates as $arrayOfLaneAccessorialRatesLaneAccessorialRatesItem) {
            // validation for constraint: itemType
            if (!$arrayOfLaneAccessorialRatesLaneAccessorialRatesItem instanceof \StructType\LaneAccessorialRates) {
                throw new \InvalidArgumentException(sprintf('The LaneAccessorialRates property can only contain items of \StructType\LaneAccessorialRates, "%s" given', is_object($arrayOfLaneAccessorialRatesLaneAccessorialRatesItem) ? get_class($arrayOfLaneAccessorialRatesLaneAccessorialRatesItem) : gettype($arrayOfLaneAccessorialRatesLaneAccessorialRatesItem)), __LINE__);
            }
        }
        if (is_null($laneAccessorialRates) || (is_array($laneAccessorialRates) && empty($laneAccessorialRates))) {
            unset($this->LaneAccessorialRates);
        } else {
            $this->LaneAccessorialRates = $laneAccessorialRates;
        }
        return $this;
    }
    /**
     * Add item to LaneAccessorialRates value
     * @throws \InvalidArgumentException
     * @param \StructType\LaneAccessorialRates $item
     * @return \ArrayType\ArrayOfLaneAccessorialRates
     */
    public function addToLaneAccessorialRates(\StructType\LaneAccessorialRates $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LaneAccessorialRates) {
            throw new \InvalidArgumentException(sprintf('The LaneAccessorialRates property can only contain items of \StructType\LaneAccessorialRates, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LaneAccessorialRates[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LaneAccessorialRates|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LaneAccessorialRates|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LaneAccessorialRates|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LaneAccessorialRates|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LaneAccessorialRates|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LaneAccessorialRates
     */
    public function getAttributeName()
    {
        return 'LaneAccessorialRates';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLaneAccessorialRates
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
