<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetProfiles StructType
 * @subpackage Structs
 */
class GetProfiles extends AbstractStructBase
{
    /**
     * The userToken
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $userToken;
    /**
     * The srvToken
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $srvToken;
    /**
     * Constructor method for GetProfiles
     * @uses GetProfiles::setUserToken()
     * @uses GetProfiles::setSrvToken()
     * @param string $userToken
     * @param string $srvToken
     */
    public function __construct($userToken = null, $srvToken = null)
    {
        $this
            ->setUserToken($userToken)
            ->setSrvToken($srvToken);
    }
    /**
     * Get userToken value
     * @return string|null
     */
    public function getUserToken()
    {
        return $this->userToken;
    }
    /**
     * Set userToken value
     * @param string $userToken
     * @return \StructType\GetProfiles
     */
    public function setUserToken($userToken = null)
    {
        // validation for constraint: string
        if (!is_null($userToken) && !is_string($userToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userToken)), __LINE__);
        }
        $this->userToken = $userToken;
        return $this;
    }
    /**
     * Get srvToken value
     * @return string|null
     */
    public function getSrvToken()
    {
        return $this->srvToken;
    }
    /**
     * Set srvToken value
     * @param string $srvToken
     * @return \StructType\GetProfiles
     */
    public function setSrvToken($srvToken = null)
    {
        // validation for constraint: string
        if (!is_null($srvToken) && !is_string($srvToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($srvToken)), __LINE__);
        }
        $this->srvToken = $srvToken;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetProfiles
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
