<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LaneAccessorialRates StructType
 * @subpackage Structs
 */
class LaneAccessorialRates extends AbstractStructBase
{
    /**
     * The IsExcluded
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsExcluded;
    /**
     * The IsAvailable
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsAvailable;
    /**
     * The IsExcludedParent
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsExcludedParent;
    /**
     * The AccessorialID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $AccessorialID;
    /**
     * The AccessorialRate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $AccessorialRate;
    /**
     * The AccessorialType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $AccessorialType;
    /**
     * The AccessorialCharge
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $AccessorialCharge;
    /**
     * The IsIncluded
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsIncluded;
    /**
     * The IsNotRated
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsNotRated;
    /**
     * The ErrorMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * The AccessorialDescription
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AccessorialDescription;
    /**
     * The AccessorialCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AccessorialCode;
    /**
     * The Message
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Message;
    /**
     * Constructor method for LaneAccessorialRates
     * @uses LaneAccessorialRates::setIsExcluded()
     * @uses LaneAccessorialRates::setIsAvailable()
     * @uses LaneAccessorialRates::setIsExcludedParent()
     * @uses LaneAccessorialRates::setAccessorialID()
     * @uses LaneAccessorialRates::setAccessorialRate()
     * @uses LaneAccessorialRates::setAccessorialType()
     * @uses LaneAccessorialRates::setAccessorialCharge()
     * @uses LaneAccessorialRates::setIsIncluded()
     * @uses LaneAccessorialRates::setIsNotRated()
     * @uses LaneAccessorialRates::setErrorMessage()
     * @uses LaneAccessorialRates::setAccessorialDescription()
     * @uses LaneAccessorialRates::setAccessorialCode()
     * @uses LaneAccessorialRates::setMessage()
     * @param bool $isExcluded
     * @param bool $isAvailable
     * @param bool $isExcludedParent
     * @param int $accessorialID
     * @param float $accessorialRate
     * @param int $accessorialType
     * @param float $accessorialCharge
     * @param bool $isIncluded
     * @param bool $isNotRated
     * @param string $errorMessage
     * @param string $accessorialDescription
     * @param string $accessorialCode
     * @param string $message
     */
    public function __construct($isExcluded = null, $isAvailable = null, $isExcludedParent = null, $accessorialID = null, $accessorialRate = null, $accessorialType = null, $accessorialCharge = null, $isIncluded = null, $isNotRated = null, $errorMessage = null, $accessorialDescription = null, $accessorialCode = null, $message = null)
    {
        $this
            ->setIsExcluded($isExcluded)
            ->setIsAvailable($isAvailable)
            ->setIsExcludedParent($isExcludedParent)
            ->setAccessorialID($accessorialID)
            ->setAccessorialRate($accessorialRate)
            ->setAccessorialType($accessorialType)
            ->setAccessorialCharge($accessorialCharge)
            ->setIsIncluded($isIncluded)
            ->setIsNotRated($isNotRated)
            ->setErrorMessage($errorMessage)
            ->setAccessorialDescription($accessorialDescription)
            ->setAccessorialCode($accessorialCode)
            ->setMessage($message);
    }
    /**
     * Get IsExcluded value
     * @return bool
     */
    public function getIsExcluded()
    {
        return $this->IsExcluded;
    }
    /**
     * Set IsExcluded value
     * @param bool $isExcluded
     * @return \StructType\LaneAccessorialRates
     */
    public function setIsExcluded($isExcluded = null)
    {
        // validation for constraint: boolean
        if (!is_null($isExcluded) && !is_bool($isExcluded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isExcluded)), __LINE__);
        }
        $this->IsExcluded = $isExcluded;
        return $this;
    }
    /**
     * Get IsAvailable value
     * @return bool
     */
    public function getIsAvailable()
    {
        return $this->IsAvailable;
    }
    /**
     * Set IsAvailable value
     * @param bool $isAvailable
     * @return \StructType\LaneAccessorialRates
     */
    public function setIsAvailable($isAvailable = null)
    {
        // validation for constraint: boolean
        if (!is_null($isAvailable) && !is_bool($isAvailable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isAvailable)), __LINE__);
        }
        $this->IsAvailable = $isAvailable;
        return $this;
    }
    /**
     * Get IsExcludedParent value
     * @return bool
     */
    public function getIsExcludedParent()
    {
        return $this->IsExcludedParent;
    }
    /**
     * Set IsExcludedParent value
     * @param bool $isExcludedParent
     * @return \StructType\LaneAccessorialRates
     */
    public function setIsExcludedParent($isExcludedParent = null)
    {
        // validation for constraint: boolean
        if (!is_null($isExcludedParent) && !is_bool($isExcludedParent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isExcludedParent)), __LINE__);
        }
        $this->IsExcludedParent = $isExcludedParent;
        return $this;
    }
    /**
     * Get AccessorialID value
     * @return int
     */
    public function getAccessorialID()
    {
        return $this->AccessorialID;
    }
    /**
     * Set AccessorialID value
     * @param int $accessorialID
     * @return \StructType\LaneAccessorialRates
     */
    public function setAccessorialID($accessorialID = null)
    {
        // validation for constraint: int
        if (!is_null($accessorialID) && !is_numeric($accessorialID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($accessorialID)), __LINE__);
        }
        $this->AccessorialID = $accessorialID;
        return $this;
    }
    /**
     * Get AccessorialRate value
     * @return float
     */
    public function getAccessorialRate()
    {
        return $this->AccessorialRate;
    }
    /**
     * Set AccessorialRate value
     * @param float $accessorialRate
     * @return \StructType\LaneAccessorialRates
     */
    public function setAccessorialRate($accessorialRate = null)
    {
        $this->AccessorialRate = $accessorialRate;
        return $this;
    }
    /**
     * Get AccessorialType value
     * @return int
     */
    public function getAccessorialType()
    {
        return $this->AccessorialType;
    }
    /**
     * Set AccessorialType value
     * @param int $accessorialType
     * @return \StructType\LaneAccessorialRates
     */
    public function setAccessorialType($accessorialType = null)
    {
        // validation for constraint: int
        if (!is_null($accessorialType) && !is_numeric($accessorialType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($accessorialType)), __LINE__);
        }
        $this->AccessorialType = $accessorialType;
        return $this;
    }
    /**
     * Get AccessorialCharge value
     * @return float
     */
    public function getAccessorialCharge()
    {
        return $this->AccessorialCharge;
    }
    /**
     * Set AccessorialCharge value
     * @param float $accessorialCharge
     * @return \StructType\LaneAccessorialRates
     */
    public function setAccessorialCharge($accessorialCharge = null)
    {
        $this->AccessorialCharge = $accessorialCharge;
        return $this;
    }
    /**
     * Get IsIncluded value
     * @return bool
     */
    public function getIsIncluded()
    {
        return $this->IsIncluded;
    }
    /**
     * Set IsIncluded value
     * @param bool $isIncluded
     * @return \StructType\LaneAccessorialRates
     */
    public function setIsIncluded($isIncluded = null)
    {
        // validation for constraint: boolean
        if (!is_null($isIncluded) && !is_bool($isIncluded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isIncluded)), __LINE__);
        }
        $this->IsIncluded = $isIncluded;
        return $this;
    }
    /**
     * Get IsNotRated value
     * @return bool
     */
    public function getIsNotRated()
    {
        return $this->IsNotRated;
    }
    /**
     * Set IsNotRated value
     * @param bool $isNotRated
     * @return \StructType\LaneAccessorialRates
     */
    public function setIsNotRated($isNotRated = null)
    {
        // validation for constraint: boolean
        if (!is_null($isNotRated) && !is_bool($isNotRated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isNotRated)), __LINE__);
        }
        $this->IsNotRated = $isNotRated;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \StructType\LaneAccessorialRates
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get AccessorialDescription value
     * @return string|null
     */
    public function getAccessorialDescription()
    {
        return $this->AccessorialDescription;
    }
    /**
     * Set AccessorialDescription value
     * @param string $accessorialDescription
     * @return \StructType\LaneAccessorialRates
     */
    public function setAccessorialDescription($accessorialDescription = null)
    {
        // validation for constraint: string
        if (!is_null($accessorialDescription) && !is_string($accessorialDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accessorialDescription)), __LINE__);
        }
        $this->AccessorialDescription = $accessorialDescription;
        return $this;
    }
    /**
     * Get AccessorialCode value
     * @return string|null
     */
    public function getAccessorialCode()
    {
        return $this->AccessorialCode;
    }
    /**
     * Set AccessorialCode value
     * @param string $accessorialCode
     * @return \StructType\LaneAccessorialRates
     */
    public function setAccessorialCode($accessorialCode = null)
    {
        // validation for constraint: string
        if (!is_null($accessorialCode) && !is_string($accessorialCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accessorialCode)), __LINE__);
        }
        $this->AccessorialCode = $accessorialCode;
        return $this;
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \StructType\LaneAccessorialRates
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LaneAccessorialRates
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
