<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RatingResult StructType
 * @subpackage Structs
 */
class RatingResult extends AbstractStructBase
{
    /**
     * The Miles
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Miles;
    /**
     * The Status
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Status;
    /**
     * The ErrorMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * The ContractResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\LTLRatingResponse2
     */
    public $ContractResult;
    /**
     * The BenchMarkResponse
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\LTLRatingResponse2
     */
    public $BenchMarkResponse;
    /**
     * The LeastCostCarriers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfLTLRatingResponse2
     */
    public $LeastCostCarriers;
    /**
     * Constructor method for RatingResult
     * @uses RatingResult::setMiles()
     * @uses RatingResult::setStatus()
     * @uses RatingResult::setErrorMessage()
     * @uses RatingResult::setContractResult()
     * @uses RatingResult::setBenchMarkResponse()
     * @uses RatingResult::setLeastCostCarriers()
     * @param float $miles
     * @param string $status
     * @param string $errorMessage
     * @param \StructType\LTLRatingResponse2 $contractResult
     * @param \StructType\LTLRatingResponse2 $benchMarkResponse
     * @param \ArrayType\ArrayOfLTLRatingResponse2 $leastCostCarriers
     */
    public function __construct($miles = null, $status = null, $errorMessage = null, \StructType\LTLRatingResponse2 $contractResult = null, \StructType\LTLRatingResponse2 $benchMarkResponse = null, \ArrayType\ArrayOfLTLRatingResponse2 $leastCostCarriers = null)
    {
        $this
            ->setMiles($miles)
            ->setStatus($status)
            ->setErrorMessage($errorMessage)
            ->setContractResult($contractResult)
            ->setBenchMarkResponse($benchMarkResponse)
            ->setLeastCostCarriers($leastCostCarriers);
    }
    /**
     * Get Miles value
     * @return float
     */
    public function getMiles()
    {
        return $this->Miles;
    }
    /**
     * Set Miles value
     * @param float $miles
     * @return \StructType\RatingResult
     */
    public function setMiles($miles = null)
    {
        $this->Miles = $miles;
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \StructType\RatingResult
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \StructType\RatingResult
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get ContractResult value
     * @return \StructType\LTLRatingResponse2|null
     */
    public function getContractResult()
    {
        return $this->ContractResult;
    }
    /**
     * Set ContractResult value
     * @param \StructType\LTLRatingResponse2 $contractResult
     * @return \StructType\RatingResult
     */
    public function setContractResult(\StructType\LTLRatingResponse2 $contractResult = null)
    {
        $this->ContractResult = $contractResult;
        return $this;
    }
    /**
     * Get BenchMarkResponse value
     * @return \StructType\LTLRatingResponse2|null
     */
    public function getBenchMarkResponse()
    {
        return $this->BenchMarkResponse;
    }
    /**
     * Set BenchMarkResponse value
     * @param \StructType\LTLRatingResponse2 $benchMarkResponse
     * @return \StructType\RatingResult
     */
    public function setBenchMarkResponse(\StructType\LTLRatingResponse2 $benchMarkResponse = null)
    {
        $this->BenchMarkResponse = $benchMarkResponse;
        return $this;
    }
    /**
     * Get LeastCostCarriers value
     * @return \ArrayType\ArrayOfLTLRatingResponse2|null
     */
    public function getLeastCostCarriers()
    {
        return $this->LeastCostCarriers;
    }
    /**
     * Set LeastCostCarriers value
     * @param \ArrayType\ArrayOfLTLRatingResponse2 $leastCostCarriers
     * @return \StructType\RatingResult
     */
    public function setLeastCostCarriers(\ArrayType\ArrayOfLTLRatingResponse2 $leastCostCarriers = null)
    {
        $this->LeastCostCarriers = $leastCostCarriers;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RatingResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
